
;Copy OneOnOne 1.00
;Copyright (c) 2022, Tycho Veltmeijer.
;All rights reserved.

application_json db 'application/json',0

resultName db 'result',0
errName db 'error'
emptyError db 0

statsStr db 'stats',0

errDir1 db 'Directory1 missing',0
errDir2 db 'Directory2 missing',0
errWorking db 'The system is busy',0
errNotStartedStr db 'Not started yet',0
errStartMissingStr db 'Start missing',0
errLenMissingStr db 'Length missing',0
errListArrayStr db 'List is not a valid JSon array',0
errUnknowIdInListStr db "Not all id's in the list are valid",0
errNotComparedStr db 'Comparing is not finished yet!',0
stoppingMessage  db 'Stopping...',0

;result enum
resultEnum:
db 'There is no result.',0                                                                                                                                     ;0
db 'The action was successful.',0                                                                                                                              ;1
db 'The size of file in path1 does not match the size it had at the moment it was found during the compare process.',0                                         ;2
db 'The size of file in path2 does not match the size it had at the moment it was found during the compare process.',0                                         ;3
db 'The attributes of file in path1 do not match the attributes it had at the moment it was found during the compare process.',0                               ;4
db 'The attributes of file in path2 do not match the attributes it had at the moment it was found during the compare process.',0                               ;5
db 'The last modified date/time of file in path1 does not match the last modified date/time it had at the moment it was found during the compare process.',0   ;6
db 'The last modified date/time of file in path2 does not match the last modified date/time it had at the moment it was found during the compare process.',0   ;7
db 'The file in path1 was not found.',0                                                                                                                        ;8
db 'The file in path2 was not found.',0                                                                                                                        ;9
db 'The file in path2 could not be opened to be written to.',0                                                                                                 ;10
db 'A read operation was failed on file in path1.',0                                                                                                           ;11
db 'A write operation was failed on file in path2.',0                                                                                                          ;12
db 'Could not set the last modified date/time of file in path 2.',0                                                                                            ;13
db 'After copying the file, the size of the file in path2`still does not match the size of the file path1.',0                                                  ;14
db 'After chancing, the attributes of the file in path2 still do not match the attributes of the file in path1.',0                                             ;15
db 'Could not remove file.',0                                                                                                                                  ;16
db 'The file is copied successfully, but the attributes of the file in path2 file do not match the attributes of the file in path1.',0                                      ;17
db 0 ;end list

path1Str db 'dir1',0
path2Str db 'dir2',0
statusStr db 'status',0
ScanningStr db 'scanning',0
backupingStr db 'backuping',0
DoneStr db 'done',0
CountedSizeToBackupStr db 'sizeToBackup',0
FilesToRemoveStr db 'filesToRemove',0
FilesToChangeAttributesStr db 'filesToChangeAttributes',0

obstaclesStr db 'obstacles',0
displayNameStr db 'displayName',0
runningStr db 'running',0
disableManualUrlStr db 'disableManualUrl',0
wDefStr db 'Windows Defender Realtime Security',0
wDefUrlStr db 'https://support.microsoft.com/en-us/windows/turn-off-defender-antivirus-protection-in-windows-security-99e6004f-c54c-8509-773c-a4d776b77960',0



CurrentFolderStr db 'currentFolder',0
CurrentFileStr db 'currentFile',0

PathStr db 'path',0
CountedDirsStr db 'dirs',0
CountedFilesStr db 'files',0
CountedSizeStr db 'size',0
CountedErrPathStr db 'noAccessDirs',0

modifiedAttributesStr db 'modifiedAttributes',0
modifiedTimeDateStr db 'modifiedTimeDate',0
modifiedSizeStr db 'modifiedSize',0
deletedfilesStr db 'deletedfiles',0
addedfilesStr db 'addedfiles',0
removedfilesStr db 'removedfiles',0

formated db 'formatted',0
number db 'number',0


noAccessFilesStr db 'noAccessFiles',0

;minStr db 'min',0
lenStr db 'length',0

filenameStr db 'filename',0
oldStr db 'old',0
newStr db 'new',0
listStr db 'list',0

timesStartedStr db 'timesStarted',0
selectedStr db 'selected',0
resultStr db 'result',0
resultsStr db 'results',0
copiedSizeStr db 'copiedSize',0
changedAttributesStr db 'changedAttributes',0
changedIncrementalstr db 'changedIncremental',0

;When action 'Start' is initiated, all pointers are released and replaced with new ones.
;Other actions may still use one of those pointers, therefor this collection is introduced.
;This is used as a lock, full lock if action 'start' is executed, write lock if any othjer action is called.
;Start can only get a full lock if no other thread had write locked it, and therefore waits until they are finished.
freeLock pointer ?

;This is set to 1 if acion start is called, so other actions now that they should stop, so action start can be executed
tryToRestart dd 0

SEND_WINDOWS_DEFENDER_STATUS equ 0x1

;for buffer
macro push64NumJson_buffer num,formatType
{ common
    push 1                         ;may not be empty
    push 0xB                       ;end of the collection

      if (formatType and 0xFFFF) = 0x4 | (formatType and 0xFFFF) = 0x5
        if used is32
          push num                   ;counted size
        else
          if num eq rax | num eq rcx | num eq rsi | num eq rdi | num eq rbx | num eq rdx | num eq r8 | num eq r9 | num eq r10
            push num                   ;counted size
          else
            push [num]                 ;counted size
          end if
        end if
      else
        push num                     ;counted size
      end if
      push formatType or 0x200000 or 0x800000  ;formated to "GB (5.000.000.000 bytes)"  0x200000=escape string as JSON string, 0x800000=is value in JSON object
      push formated                         ;"formated"
      push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

      if (formatType and 0xFFFF) = 0x4 | (formatType and 0xFFFF) = 0x5
        if used is32
          push num                   ;number
        else
          if num eq rax | num eq rcx | num eq rsi | num eq rdi | num eq rbx | num eq rdx | num eq r8 | num eq r9 | num eq r10
            push num                   ;counted size
          else
            push [num]                 ;counted size
          end if                    ;counted size
        end if
        push 0x4                     ;x64 num number
      else
        push num                     ;number
        push 0x3                     ;x32/64 number
      end if

     push number                   ;"number"
     push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma

    push 1                       ;"May not be empty
    push 0xA                     ;Create an object "{"
}

;for buffer
macro push64NumJsonNoPointer_buffer num,formatType
{ common
local ..setType4
local ..setType3
local ..dontSetType
    push 1                         ;may not be empty
    push 0xB                       ;end of the collection


      push num                         ;counted size
      push formatType  ;formated to "GB (5.000.000.000 bytes)", 0x200000=escape string as JSON string, 0x800000=is value in JSON object
      or pdword [pesp],0x200000 or 0x800000
      push formated                    ;"formated"
      push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

      push num                     ;number
      push formatType              ;x32/64 number

      and  pdword [pesp],0xFFFF    ;remove flags

      cmp pdword [pesp],0x5
      je ..setType4
      cmp pdword [pesp],0xD
      je ..setType4
      cmp pdword [pesp],0xC
      ;je ..setType3
      jne ..dontSetType

    ..setType3:
      mov pdword [pesp],3
      jmp ..dontSetType

    ..setType4:
      mov pdword [pesp],4
      ;jmp ..dontSetType

    ..dontSetType:
     push number                   ;"number"
     push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma

    push 1                       ;ASCI string
    push 0xA                     ;Create an object "{"
}

macro waitForLock pointer
{ common
  local ..lockIsSet
  local ..setLockAgain

  push pecx
  push peax
  push pedx

  mov pedx,pointer

  ..setLockAgain:
    xor al,al
    mov cl,1
    lock cmpxchg byte [pedx],cl
    jz ..lockIsSet

      push 1
      call sleep

    jmp ..setLockAgain

..lockIsSet:
  pop pedx
  pop peax
  pop pecx
}

;------------------------------------------------------------------------------
;This function will initialize the ClientSession (if TCP) and handle the connection (if HTTP)
;-------------------------     -----------------------------------------------------
HandleConnection:
StartProc 2 ;Set arguments on stack
call denter

  xor eax,eax ;return value

  push endCommandExpected-commandExpected
  call GetMemLocation
  mov pebx,peax

  mov esi,0x1 ;GET_FROM_CLIENTSESSION
  mov eax,CPO_NAME_MAX_SIZE
  call GetPluginDataInt
  mov pedx,pecx ;(R/E)DX => maximum allowed size

  ;mov esi,0x1 ;GET_FROM_CLIENTSESSION
  mov eax,CPO_NAME_MAX_TIMEOUT
  call GetPluginDataInt ;(R/E)CX => maximum allowed timeout


  push endCommandExpected-commandExpected-1

  push pesp                  ;&len
  push pebx                  ;buf
  push pecx                  ;maxTimeToReceive
  push RSF_RETURN_ON_COMPLETE or RSF_PEEK_DATA ;flags
  push pdword [pebp+psize*3] ;ClientSession
  push pdword [pebp+psize*2] ;ProtocolSession
  call [RecvData]

  add pesp,psize

  call endCommandExpected
commandExpected:
  ;db 'POST /api',0
  db 'GET /api/?',0
endCommandExpected:
  push pebx
  call strcmp
  jnz letOtherProtocolHandle

push pebx
call FreeMemLocation

if used is32
  sub pesp,8*5 ;make room for 5 long long's
end if

;create size for a ResponseHeader structure
sub pesp,sizeOfResponseHeaderSize

clientLoop:
  ;zero structure and long longs
  mov pedi,pesp

  push pecx ;save maxTimeToReceive

  if used is32
    mov ecx,sizeOfResponseHeaderSize+(8*5)
  else
    mov ecx,sizeOfResponseHeaderSize
  end if
  xor eax,eax
  rep stosb

  pop pecx ;restore maxTimeToReceive

  if used is32
    ;set contentLength
    lea eax,dword [pesp+sizeOfResponseHeaderSize]
    mov dword [pesp+8+(psize*3)],eax
    ;set contentRangeOffset
    lea eax,dword [pesp+8*1+sizeOfResponseHeaderSize]
    mov dword [pesp+8+(psize*4)],eax
    ;set contentRangeTotalLength
    lea eax,dword [pesp+8*2+sizeOfResponseHeaderSize]
    mov dword [pesp+8+(psize*5)],eax
    ;set lastModified
    lea peax,dword [pesp+8*3+sizeOfResponseHeaderSize]
    mov dword [pesp+8+(psize*6)],eax
    ;set expires
    lea peax,dword [pesp+8*4+sizeOfResponseHeaderSize]
    mov dword [pesp+8+(psize*7)],eax

    ;add dword [esp+8+(psize*3)],sizeOfResponseHeaderSize
  end if

  ;set members from the ResponseHeader structure


  mov dword [pesp+4*2+psize],application_json ;contentType
  mov pdword [pesp+8],200 ;set status code

  push 0

  ;-------------
  ;Receive HTTP header
  ;-------------
  push pesp ;*error
  push RPF_USE_TIME_LIMIT or RPF_USE_HEADER_SIZE_LIMIT or RPF_CHECK_VALID_METHOD ;flags
  push pecx         ;maxTimeToReceive
  push pedx         ;maxHeaderSizeLimit
  push pdword [pebp+psize*3] ;ClientSession
  push pdword [pebp+psize*2] ;ProtocolSession
  call [RecvAndParseHTTP]
  mov pebx,peax

  pop peax ;error code

  test pebx,pebx
  jz endHandleConnection

  mov pedi,pdword [pebx+psize*5] ;URLbuffer

  ;-push 0
  ;-push pedi
  ;-call [ConvertEscapedCharactersToBytes]

  ;-push pedi
  ;-call [DeleteDoubleSlashesInUrl]

  ;-push pedi
  ;-call [DecodeURL]
  ;-test eax,eax
  ;-jz endHandleConnection ;the url has to many parent directories / hack atempt

  mov peax,pesp

  push DEFAULT_SENDTIMEOUT   ;maxTimeToReceive
  push peax                  ;ResponseHeader
  push pdword [pebp+psize*3] ;ClientSession
  push pdword [pebp+psize*2] ;ProtocolSession
  call [SendHTTPHeader]



  mov pedi,pdword [pebx+psize*2] ;optionsQuestionmarkStringIndexedCollection

  call pushActionStr  ;push "action"
    db 'action',0
  pushActionStr:
  push pedi           ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz endHandleConnection

  ;un-escape before use
  push ETBF_UNESCAPE_ADD_SIGN_AS_SPACE
  push peax
  call [ConvertEscapedCharactersToBytes]

  ;Get hash of "action"
  push peax ;name of the variable
  call GenerateHashCaseInsensitiveSafe

  cmp eax,0xEB9748B4 ;Start
  je StartComparing
  cmp eax,0xE9781D70 ;Stop
  je StopComparing
  cmp eax,0xD7383804 ;Get-Progress
  je GetProgess
  cmp eax,0xA821CD9A ;Get-No-Access-Dir1
  je GetNoAccessDir1
  cmp eax,0xA821CD9B ;Get-No-Access-Dir2
  je GetNoAccessDir2
  cmp eax,0x82C20B51 ;Get-Deleted
  je GetDeleted
  cmp eax,0xB3FE361B ;Get-Added
  je GetAdded
  cmp eax,0xD419D1AC ;Get-Modified-Attributes
  je GetModifiedAttributes
  cmp eax,0x93116EE  ;Get-Modified-Size
  je GetModifiedSize
  cmp eax,0xFCB6F955 ;Get-Modified-DateTime
  je GetModifiedDateTime

  cmp eax,0xC0F21351 ;Get-Deleted-Results
  je GetDeletedResults
  cmp eax,0x8B234F7C ;Get-Added-Results
  je GetAddedResults
  cmp eax,0x1C436B18 ;Get-Modified-Attributes-Results
  je GetModifiedAttributesResults
  cmp eax,0x5D78825D  ;Get-Modified-Size-Results
  je GetModifiedSizeResults
  cmp eax,0xC56C083F ;Get-Modified-DateTime-Results
  je GetModifiedDateTimeResults

  cmp eax,0xF539C624 ;Get-Result-Enum
  je GetResultEnum
  cmp eax,0x3D4B41FF ;Start-Backup
  je startBackup
  cmp eax,0xF965D97E ;Stop-Backup
  je stopBackup

xor ecx,ecx ;unselect files
  cmp eax,0xDD1BB9AF ;Unselect-Deleted
  je SelectOrUnselectDeleted
  cmp eax,0x2D679CD5 ;Unselect-Added
  je SelectOrUnselectAdded
  cmp eax,0x79B4B792 ;Unselect-Modified-Attributes
  je SelectOrUnselectModifiedAttributes
  cmp eax,0xC2AA8054 ;Unselect-Modified-Size
  je SelectOrUnselectModifiedSize
  cmp eax,0x934D64ED ;Unselect-Modified-DateTime
  je SelectOrUnselectModifiedDateTime

inc ecx ;select files
  cmp eax,0x3D1A01A1 ;Select-Deleted
  je SelectOrUnselectDeleted
  cmp eax,0xF2E795F4 ;Select-Added
  je SelectOrUnselectAdded
  cmp eax,0x799936A8 ;Select-Modified-Attributes
  je SelectOrUnselectModifiedAttributes
  cmp eax,0xE270004D ;Select-Modified-Size
  je SelectOrUnselectModifiedSize
  cmp eax,0xEB4CF6E9 ;Select-Modified-DateTime
  je SelectOrUnselectModifiedDateTime


jmp goToExample

;----------------------------------
;-----------Stop-Backup------------
;----------------------------------
stopBackup:
  cmp [Done],0
  je errNotCompared

  xor esi,esi ;no flags
  cmp [Working],2
  jne errNotStarted

  mov [stopBackupNow],1

  xor eax,eax
  inc eax     ;no error
  mov pedx,emptyError
  xor esi,esi ;no flags
  jmp endStartComparing

;----------------------------------
;-----------Start-Backup-----------
;----------------------------------
startBackup:
  cmp [Done],0
  je errNotCompared

  xor al,al
  xor ah,ah
  add ah,2
  lock cmpxchg byte [Working],ah  ;if working==AL (=0) then F is set and set Working = ah(=2) }else{ Z is unset
  jnz errAlreadyWorking

  mov [stopBackupNow],0

  push 0
  push StartBackuping
  call createthread

  xor eax,eax
  inc eax     ;no error
  mov pedx,emptyError
  xor esi,esi ;no flags
  jmp endStartComparing

;----------------------------------
;-------Get-Deleted-Results--------
;----------------------------------  
GetDeletedResults:
  mov pedx,[Deleted_files_result]
  jmp GetResults

;----------------------------------
;--------Get-Added-Results---------
;---------------------------------- 
GetAddedResults:
  mov pedx,[Added_files_result]
  jmp GetResults

;----------------------------------
;--Get-Modified-Attributes-Results-
;---------------------------------- 
GetModifiedAttributesResults:
  mov pedx,[Modified_Attributes_files_result]
  jmp GetResults

;----------------------------------
;----Get-Modified-Size-Results-----
;---------------------------------- 
GetModifiedSizeResults:
  mov pedx,[Modified_Size_files_result]
  jmp GetResults

;----------------------------------
;--Get-Modified-DateTime-Results---
;---------------------------------- 
GetModifiedDateTimeResults:
  mov pedx,[Modified_TimeDate_files_result]
  ;jmp GetResults

GetResults:
  call __pushStartStr  ;push "start"
    db 'start',0
  __pushStartStr:
  push pedi           ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz errStartMissing  ;jump if min is missing

  ;un-escape before use
  push ETBF_UNESCAPE_ADD_SIGN_AS_SPACE
  push peax
  call [ConvertEscapedCharactersToBytes]
  
  push 10
  push peax
  call StrToInt
  mov pesi,peax      ;ESI => start

  call __pushLenStr  ;push "length"
    db 'length',0
  __pushLenStr:
  push pedi           ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz errLenMissing  ;jump if length is missing

  ;un-escape before use
  push ETBF_UNESCAPE_ADD_SIGN_AS_SPACE
  push peax
  call [ConvertEscapedCharactersToBytes]
  
  push 10
  push peax
  call StrToInt
  mov pecx,peax      ;ECX => length

  ;set lock, so pointers cannot be freed until this action finishes
  push [freeLock]
  call LockListWriteAcces

  ;r8 is not automaticly saved by calls to TV's server
  if used is64
    push r8
  end if

  ;Free HTTPSession, since we don't need it anymore!
  push pebx
  call [FreeHTTPSession]

  ;r8 is not automaticly saved by calls to TV's server
  if used is64
    pop r8
  end if

  push pdword [pebp+psize*3] ;ClientSession (param2)
  push pdword [pebp+psize*2] ;ProtocolSession (param1)
  push sendBufferCacllback   ;callback function
  call createNewBuffer
  mov pebx,peax   ;R/EBX<=Buffer!!

  mov pedi,pedx ;R/EDI => the collection to work on

  xor edx,edx ;actual items count

  push 0 ;last item in list for appendBuffer
  push 1                     ;not empty
  push 0xA                   ;Create an object "{"
  push resultStr             ;"list"
  push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma
  push 1                                        ;"May not be empty
  push 0xA                                      ;Create an object "{"
  push pebx
  call appendBuffer 

  ;check Item exists
  push pedi          ;Collection
  call CountItems    ;Get next item
  test peax,peax
  jz noResults

  loopThroughResultItems:

    ;check Item exists
    push pedi          ;Collection
    call CountItems    ;Get next item
    cmp peax,pesi
    jb isNotObject__Result ;stop if next item does not exist  
    
    test pesi,pesi
    jz isNotObject__Result ;stop if next item does not exist  
      push 0 ;last item

      push pesi          ;current item
      push pedi          ;list
      call GetDwordItem
    
      push peax  ;result
      push 0x3 or 0x200000 or 0x800000 ;number , 0x200000=escape string as JSON string, 0x800000=is value in JSON object

      push pesi ;item number
      push 0x3 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON
      
      test pedx,pedx
      jnz notFirstItem

        or pdword [pesp],0x1000000 ;0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma
      
      notFirstItem:
      push pebx
      call appendBuffer
      
      inc pedx

  isNotObject__Result:
  ;cancel this action is start is trying to be executed
  cmp [tryToRestart],1
  je noResults

  inc pesi
  dec pecx
  jnz loopThroughResultItems

   noResults:
   ;release lock, so pointers can be freed again
   push [freeLock]
   call ExternalUnlockListWriteAcces

   push 0                     ;last item
   push 1                     ;may not be empty
   push 0xB                   ;end of the collection
   push pedx                  ;items in list
   push 0x3                   ;number
   push lenStr                ;"length"
   push 0x1 or 0x400000       ;ANSI string 0x400000=is item name in JSON
   push 1                     ;may not be empty
   push 0xB                   ;end of the collection
   push pebx
   call appendBuffer

   push pebx
   call freeBuffer
   xor pebx,pebx
  jmp errHandleConnection


;----------------------------------
;---------Get-Result-Enum----------
;----------------------------------
GetResultEnum:
  push pdword [pebp+psize*3] ;ClientSession (param2)
  push pdword [pebp+psize*2] ;ProtocolSession (param1)
  push sendBufferCacllback   ;callback function
  call createNewBuffer
  mov pedx,peax   ;R/ECX<=Buffer!!

  mov pesi,resultEnum
  xor ecx,ecx

  push 0 ;last item
  push 1       ;may not be empty
  push 0xB     ;'}'
  loopThroughEnum:
    push pesi ;enum item
    push 0x1 or 0x200000 or 0x800000 ;ANSI string , 0x200000=escape string as JSON string, 0x800000=is value in JSON object

    push pecx ;counter
    push 0x3 or 0x400000  ;number, 0x400000=is item name in JSON

    push pesi
    call strlen
    add pesi,peax
    inc pesi

    inc ecx ;increment counter

    cmp byte[pesi],0 ;end of the list?
  jne loopThroughEnum

  or pdword [pesp],0x1000000 ;0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma
  push 1       ;may not be empty
  push 0xA     ;'{'
  push pedx
  call appendBuffer

  push pedx
  call freeBuffer
  xor pedx,pedx
  jmp errHandleConnection


;----------------------------------
;----Select-Modified-DateTime------
;----Unselect-Modified-DateTime----
;----------------------------------
SelectOrUnselectModifiedDateTime:
  if used is64
    mov r12,dModified_TimeDate_files_size      ;the size dword collection to work on
    mov r13,Modified_TimeDate_files_selected   ;List with selected files to be deleted
    mov r14d,ecx                               ;select or unselect
    xor r15,r15                                ;use filesize to add to SizeToBackup
  else
    push 0                                     ;use filesize to add to SizeToBackup
    push ecx                                   ;select or unselect
    push Modified_TimeDate_files_selected      ;List with selected files to be deleted
    push dModified_TimeDate_files_size         ;the size dword collection to work on
    mov edx,esp
  end if
  jmp selectOrUnselectItems

;----------------------------------
;------Select-Modified-Size--------
;------Unselect-Modified-Size------
;----------------------------------
SelectOrUnselectModifiedSize:
  if used is64
    mov r12,dModified_Size_files           ;the size dword collection to work on
    mov r13,Modified_Size_files_selected   ;List with selected files to be deleted
    mov r14d,ecx                           ;select or unselect
    xor r15,r15                            ;use filesize to add to SizeToBackup
  else
    push 0                                 ;use filesize to add to SizeToBackup
    push ecx                               ;select or unselect
    push Modified_Size_files_selected      ;List with selected files to be deleted
    push dModified_Size_files              ;the size dword collection to work on
    mov edx,esp
  end if
  jmp selectOrUnselectItems

;----------------------------------
;---Select-Modified-Attributes-----
;---Unselect-Modified-Attributes---
;----------------------------------
SelectOrUnselectModifiedAttributes:
  if used is64
    mov r12,dModified_Attributes_files         ;the size dword collection to work on
    mov r13,Modified_Attributes_files_selected ;List with selected files to be deleted
    mov r14d,ecx                               ;select or unselect
    mov r15,FilesToChangeAttributes            ;add one to this pointer
  else
    push FilesToChangeAttributes               ;add one to this pointer
    push ecx                                   ;select or unselect
    push Modified_Attributes_files_selected    ;List with selected files to be deleted
    push dModified_Attributes_files            ;the size dword collection to work on
    mov edx,esp
  end if
  jmp selectOrUnselectItems

;-----------------------------
;--------Select-Added---------
;-------Unselect-Added--------
;-----------------------------
SelectOrUnselectAdded:
  if used is64
    mov r12,dAdded_files           ;the size dword collection to work on
    mov r13,Added_files_selected   ;List with selected files to be deleted
    mov r14d,ecx                   ;select or unselect
    xor r15,r15                    ;use filesize to add to SizeToBackup
  else
    push 0                         ;use filesize to add to SizeToBackup
    push ecx                       ;select or unselect
    push Added_files_selected      ;List with selected files to be deleted
    push dAdded_files              ;the size dword collection to work on
    mov edx,esp
  end if
  jmp selectOrUnselectItems

;-----------------------------
;-------Select-Deleted--------
;------Unselect-Deleted-------
;-----------------------------
SelectOrUnselectDeleted:
  if used is64
    mov r12,dDeleted_files         ;the size dword collection to work on
    mov r13,Deleted_files_selected ;List with selected files to be deleted
    mov r14d,ecx                   ;select or unselect
    mov r15,FilesToRemove          ;add one to this pointer
  else
    push FilesToRemove             ;add one to this pointer
    push ecx                       ;select or unselect
    push Deleted_files_selected    ;List with selected files to be deleted
    push dDeleted_files            ;the size dword collection to work on
    mov edx,esp
  end if
  ;jmp selectOrUnselectItems

selectOrUnselectItems:
  call pushListStr  ;push "list"
    db 'list',0
  pushListStr:
  push pedi           ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  mov pesi,peax      ;ESI => list
  test peax,peax
  jz errStartMissing  ;jump if min is missing

  ;un-escape before use
  push ETBF_UNESCAPE_ADD_SIGN_AS_SPACE
  push peax
  call [ConvertEscapedCharactersToBytes]

  ;Parse JSON array. It can only parse an array with numbers in it.
  lodsb
  cmp al,'['
  jne errListArray
  
  call CreateCollection
  mov pedi,peax      ;R/EDI => collection

  ;set lock, so pointers cannot be freed until this action finishes
  push [freeLock]
  call LockListWriteAcces

  ;lock list, since it is only used in this thread
  push FULL_LOCK
  push pedi
  call LockListAcces

  if used is64
    push qword [r12] ;List with al the items
    call CountItems
    shr rax,1 ;/2
    mov r8,rax ;R8 => amount of available items
  end if

  xor ecx,ecx
  parseList:
    test pecx,pecx ;Is the begin of the number already saved?
    jnz beginPointerIsSet
    
      mov pecx,pesi ;save begin of the number in the array
    
    beginPointerIsSet:
    lodsb
    test al,al
    jz errParseList
    cmp al,']'
    je foundEndOfList
    cmp al,','
    jne parseList

  foundEndOfList:
    push peax ;save last character

    mov byte[pesi-1],0
    ;convert the name in the list to an integer
    push 10
    push pecx
    call StrToInt
    
    if used is64
      ;ItemId must be >0 and <available items
      test rax,rax
      jz errItemIdInList
      cmp rax,r8
      ja errItemIdInList
    else
      test eax,eax
      jz errItemIdInList

      push peax

      mov eax,dword [edx]
      push dword [eax] ;List with all the items
      call CountItems
      shr eax,1 ;/2

      cmp dword [esp],eax
      pop eax
      ja errItemIdInList
    end if

    ;save the integer in the list
    push peax
    push pedi
    call AddDword
   
    xor pecx,pecx ;clear beginning the of number
    pop peax ;restore last character
    cmp al,']'
  jne parseList
  jmp endListFound

  errParseList:
    mov pecx,errListArray
    jmp err__List

  errItemIdInList:
    mov pecx,errUnknowIdInList

  err__List:
    push FULL_LOCK
    push pedi
    call ExternalUnlockListAccesEx

    push pedi
    call FreeDwordCollection

    ;release lock, so pointers can be freed again
    push [freeLock]
    call ExternalUnlockListWriteAcces
    jmp pecx
  
  endListFound:
    push pedi
    call CountItems
    test peax,peax
    jz endSelectOrUnselectItem_noLocks

    ;Lock selection list
    push FULL_LOCK
    if used is64
      push qword [r13] ;List with selected files
    else
      mov eax,dword [edx+0x4]
      push dword [eax] ;List with selected files
    end if
    call LockListAcces

    ;Lock selection list
    push FULL_LOCK
    if used is64
      push qword [r12] ;the size dword collection
    else
      mov eax,dword [edx]
      push dword [eax] ;the size dword collection
    end if
    call LockListAcces

    push pedi
    call CountItems
    mov pecx,peax ;R/ECX => amount of items in the requested list
    test pecx,pecx
    jz endSelectOrUnselectItem
    selectOrUnselectItem:
      push pecx
      push pedi
      call GetDwordItem
      mov pesi,peax ;R/ESI => current item to select or unselect
      
      if used is64
        push qword [r13] ;List with selected files
      else
        mov eax,dword [edx+0x4]
        push dword [eax] ;List with selected files
      end if
      call CountItems
      cmp peax,pesi
      jae itemExists
      
      ;add items until you added the items that is being set
      addUnavailableItems:
        push 0 ;set as unselected
        if used is64
          push qword [r13] ;List with selected files
        else
          mov eax,dword [edx+0x4]
          push dword [eax] ;List with selected files
        end if
        call AddDword
        cmp peax,pesi
      jb addUnavailableItems ;jump if the item you want to set is not yet aded
      
      itemExists:
      ;Check if value is already selected or unselected
      push pesi ;itemId
      if used is64
        push qword [r13] ;List with selected files
      else
        mov eax,dword [edx+0x4]
        push dword [eax] ;List with selected files
      end if
      call GetDwordItem
      if used is64
        cmp r14,rax             ;push if item should be selected
      else
        cmp dword [edx+0x8],eax ;push if item should be selected
      end if
      je nextSelectOrUnselectItem ;jump if not changed

      ;set selection
      if used is64
        push r14             ;push if item should be selected
      else
        push dword [edx+0x8] ;push if item should be selected
      end if
      push pesi ;itemId
      if used is64
        push qword [r13] ;List with selected files
      else
        mov eax,dword [edx+0x4]
        push dword [eax] ;List with selected files
      end if
      call ModifyDword

      if used is64
        test r15,r15
      else
        cmp dword [edx+0xC],0
      end if
      jnz addOneToSize

      ;get index of the new size
      mov peax,pesi
      if used is32
        shl eax,2 ;*4
        dec eax ;get low part
      else
        shl rax,1 ;*2
      end if
      push peax
      if used is64
        push pdword [r12]  ;dword collection
        call GetDwordItem

        test r14,r14
        jz subStractSize

        lock add [SizeToBackup],rax
        jmp nextSelectOrUnselectItem

        subStractSize:
          lock sub [SizeToBackup],rax
      else
         mov eax,dword [edx] ;get dword collection from stack
        push pdword [eax]  ;dword collection
        call GetDwordItemPointer

        cmp dword [edx+0x8],0
        je subStractSizex86

        push ecx

        mov ecx,eax
        push SizeToBackup
        call AddQwordToQword

        pop ecx
        jmp nextSelectOrUnselectItem

        subStractSizex86:
        push eax
        push SizeToBackup
        call SubQwordFromQword
      end if

      jmp nextSelectOrUnselectItem

      addOneToSize:
        if used is64
          test r14,r14
          jz subStractOneSize

            lock inc qword [r15]
            jmp nextSelectOrUnselectItem

          subStractOneSize:
            lock dec qword [r15]
        else
          push ecx

          mov ecx,1
          push dword [edx+0xC]

          cmp dword [edx+0x8],0
          je subStractOneSizex86

            call AddToQword

          pop ecx
            jmp nextSelectOrUnselectItem

          subStractOneSizex86:
            call SubToQword

          pop ecx

          ;jmp nextSelectOrUnselectItem

        end if

   nextSelectOrUnselectItem:

    ;cancel this action is start is trying to be executed
    cmp [tryToRestart],1
    je endSelectOrUnselectItem

      dec pecx
      test pecx,pecx
    jnz selectOrUnselectItem

    endSelectOrUnselectItem:
    ;unLock selection list
    push FULL_LOCK
    if used is64
      push qword [r13] ;List with selected files
    else
      mov eax,dword [edx+0x4]
      push dword [eax] ;List with selected files
    end if
    call ExternalUnlockListAccesEx

    push FULL_LOCK
    if used is64
      push qword [r12] ;the size dword collection
    else
      mov eax,dword [edx]
      push dword [eax] ;the size dword collection
    end if
    call ExternalUnlockListAccesEx

    endSelectOrUnselectItem_noLocks:
    ;release lock, so pointers can be freed again
    push [freeLock]
    call ExternalUnlockListWriteAcces

    push FULL_LOCK
    push pedi
    call ExternalUnlockListAccesEx

    push pedi
    call FreeDwordCollection

    xor eax,eax
    inc eax     ;no error
    mov pedx,emptyError
    xor esi,esi ;no flags
    jmp endStartComparing

errListArray:
  xor eax,eax ;error
  mov pedx,errListArrayStr
  xor esi,esi ;no flags
  jmp endStartComparing 

errUnknowIdInList:
  xor eax,eax ;error
  mov pedx,errUnknowIdInListStr
  xor esi,esi ;no flags
  jmp endStartComparing


;-----------------
;------stop-------
;-----------------
StopComparing:
  xor esi,esi ;no flags

  cmp [Working],0
  je errNotStarted

  mov [StopDirLoop],1

  xor eax,eax
  inc eax     ;no error
  mov pedx,stoppingMessage
  xor esi,esi ;no flags
  jmp endStartComparing


;-----
;Start comparing directories
StartComparing:

  call pushFirstDirStr  ;push "dir1"
    db 'dir1',0
  pushFirstDirStr:
  push pedi           ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  mov pesi,peax      ;ESI => dir1
  test peax,peax
  jz errDir1Missing  ;jump if dir1 is missing

  ;un-escape before use
  push ETBF_UNESCAPE_ADD_SIGN_AS_SPACE
  push peax
  call [ConvertEscapedCharactersToBytes]

  call pushSecondDirStr  ;push "dir2"
    db 'dir2',0
  pushSecondDirStr:
  push pedi           ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  mov pedi,peax      ;EDI => dir1
  test peax,peax
  jz errDir2Missing  ;jump if dir2 is missing

  ;un-escape before use
  push ETBF_UNESCAPE_ADD_SIGN_AS_SPACE
  push peax
  call [ConvertEscapedCharactersToBytes]

  xor al,al
  xor ah,ah
  inc ah
  lock cmpxchg byte [Working],ah  ;if working==AL (=0) then F is set and set Working = ah(=1) }else{ Z is unset
  jnz errAlreadyWorking

  mov [tryToRestart],1
  ;lock list, so no other actions can be executed, until this lock is released
  push FULL_LOCK
  push [freeLock]
  call LockListAcces
  mov [tryToRestart],0

  mov [Done],0

  if used is64
    inc [cStarted]
  else
    push ecx

    mov ecx,1
    push cStarted
    call AddToQword

    pop ecx
  end if

  push pesi
  call fixPath_Utf8

  ;Make copy of dir1 string
  push 0
  test eax,eax
  jnz backSlashIsAlreadyInPath

    call pushBackSlash

      BackSlash  db '\',0

    pushBackSlash:
  push 0x1  ;ANSI string
  backSlashIsAlreadyInPath:
  push pesi
  push 0x11 ;UTF-8 string
  call CreateOneString
  xchg [Path],peax
  test peax,peax
  jz dontNeedToFreePath1

    push peax
    call FreeMemLocation   ;Free old path

  dontNeedToFreePath1:
  push pedi
  call fixPath_Utf8

  ;Make copy of dir2 string
  push 0
  test eax,eax
  jnz backSlashIsAlreadyInPath2
    push BackSlash
  push 0x1  ;ANSI string
  backSlashIsAlreadyInPath2:
  push pedi
  push 0x11 ;UTF-8 string
  call CreateOneString
  xchg [Path2],peax
  test peax,peax
  jz dontNeedToFreePath2

    push peax
    call FreeMemLocation   ;Free old path

  dontNeedToFreePath2:
;-  mov ecx,(endCollections-startCollections)/psize  ;ECX => ammount of collection
;-  mov pedi,startCollections                        ;EDI => start of collections
;-  mov pesi,startCollections                        ;ESI => start of collections

;-  replaceCollections:
;-    lodsp                 ;Get current collection
;-    push peax
;-    call FreeCollection   ;Free collection if there is any

;-    call CreateCollection ;Create a new collection
;-    stosp                 ;store pointer

;-    push peax
;-    call initAntiWriteLock
;-  loop replaceCollections

  mov ecx,(endDwordCollections-startDwordCollections)/psize  ;ECX => ammount of collection
  mov pedi,startDwordCollections                        ;EDI => start of collections
  mov pesi,startDwordCollections                        ;ESI => start of collections
  replaceDwordCollections:
    lodsp                      ;Get current collection
    push peax
    call FreeDwordCollection   ;Free collection if there is any

    call CreateCollection ;Create a new collection
    stosp                 ;store pointer

    push peax
    call initAntiWriteLock
  loop replaceDwordCollections

  call freeSlicedMemory ;Free sliced memory

  mov ecx,(endCompareQwords-compareQwords)/psize   ;ECX => ammount of dwords/qwords
  mov pedi,compareQwords                           ;EDI => first qword
  xor peax,peax                                    ;Zero EAX or RAX
  zeroQwords:
    stosp                                          ;stor EAX or RAX
  loop zeroQwords


  ;allocate memory for the current folder
  push (32767*4) + 2 + 2 ;MAX_PATH with preset \\?\ + lock byte + zero word
  call GetMemLocation
  mov word [peax],0
  mov [CurrentFolderMem],peax
  add [CurrentFolderMem],2 ;add 2 bytes for lockbyte
  xchg [CurrentFolderMemLock],peax

  ;Free old pointer is exists
  push peax
  call FreeMemLocation

  ;allocate memory for the current file
  push (260*4) + 2 + 2 ;MAX_PATH + lock byte + zero word
  call GetMemLocation
  mov word [peax],0
  mov [CurrentFileMem],peax
  add [CurrentFileMem],2 ;add 2 bytes for lockbyte
  xchg [CurrentFileMemLock],peax

  ;Free old pointer is exists
  push peax
  call FreeMemLocation

  push 0
  push StarCompare
  call createthread

  ;unlock other actions
  push FULL_LOCK
  push [freeLock]
  call ExternalUnlockListAccesEx

  xor eax,eax
  inc eax     ;no error
  mov pedx,emptyError
  xor esi,esi ;no flags
  jmp endStartComparing

errLenMissing:
  xor eax,eax ;error
  mov pedx,errLenMissingStr
  xor esi,esi ;no flags
  jmp endStartComparing

errStartMissing:
  xor eax,eax ;error
  mov pedx,errStartMissingStr
  xor esi,esi ;no flags
  jmp endStartComparing

errDir1Missing:
  xor eax,eax ;error
  mov pedx,errDir1
  xor esi,esi ;no flags
  jmp endStartComparing

errDir2Missing:
  xor eax,eax ;error
  mov pedx,errDir2
  xor esi,esi ;no flags
  jmp endStartComparing

errAlreadyWorking:
  xor eax,eax ;error
  mov pedx,errWorking
  xor esi,esi ;no flags
  jmp endStartComparing

errNotStarted:
  xor eax,eax ;error
  mov pedx,errNotStartedStr
  jmp endStartComparing

errNotCompared:
  xor eax,eax ;error
  mov pedx,errNotComparedStr
  xor esi,esi ;no flags
  jmp endStartComparing


endStartComparing:
  push peax ;save error code

  push pdword [pebp+psize*3] ;ClientSession (param2)
  push pdword [pebp+psize*2] ;ProtocolSession (param1)
  push sendBufferCacllback   ;callback function
  call createNewBuffer
  mov pecx,peax   ;R/ECX<=Buffer!!

  pop peax ;restore error code

  push 0           ;last item
  push 1
  push 0xB         ;'}'

    test esi,SEND_WINDOWS_DEFENDER_STATUS
    jz dontSendWindowsDefenderStatus

    mov pesi,peax ;save error code
    call pushObstacles
    mov peax,pesi ;restore error code


  dontSendWindowsDefenderStatus:
    push peax        ;result boolean
    push 0x3         ;number
    push resultName  ;"result"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string, 0x200000=escape string as JSON string, 0x400000=is item name in JSON object
    push pedx        ;error string
    push 0x1 or 0x200000 or 0x800000         ;ANSI string, 0x200000=escape string as JSON string, 0x800000=is value in JSON object
    push errName     ;"Error"
    push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string, 0x200000=escape string as JSON string, 0x400000=is item name in JSON object, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma
  push 1
  push 0xA         ;'{'
  push pecx
  call appendBuffer

  push pecx
  call freeBuffer

  jmp errHandleConnection

;"Get-Progress" command
GetProgess:
  mov esi,SEND_WINDOWS_DEFENDER_STATUS ;0x1 ;flag for sending Windows Defender status

  cmp [Working],0
  jne startGetProgress

  cmp [Done],0
  je errNotStarted
startGetProgress:

  ;set lock, so pointers cannot be freed until this action finishes
  push [freeLock]
  call LockListWriteAcces

  push pdword [pebp+psize*3] ;ClientSession (param2)
  push pdword [pebp+psize*2] ;ProtocolSession (param1)
  push sendBufferCacllback   ;callback function
  call createNewBuffer
  mov pedx,peax   ;R/EDX<=Buffer!!

  push 0 ;last item
  push 1                       ;may not be empty
  push 0xB                     ;end of json

  push 1                       ;may not be empty
  push 0xB                     ;end of the collection

    push64NumJson_buffer changedAttributesFiles, 0x4 or 0x100000 ;changed attributes, push as doted like "5.000.000.000" and as number
    push changedAttributesStr    ;"changedAttributes"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push64NumJson_buffer removedFiles, 0x4 or 0x100000 ;removed files, push as doted like "5.000.000.000" and as number
    push removedfilesStr         ;"removedFiles"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push64NumJson_buffer backupedSize, 0x5 ;counted size, push as formated to "5GB (5.000.000.000 bytes)" and as number
    push copiedSizeStr           ;"copiedSize"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push64NumJson_buffer changedResults, 0x4 or 0x100000 ;counted dirs, push as doted like "5.000.000.000" and as number
    push changedIncrementalstr   ;"changedIncremental"
    push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma

  push 1                       ;"May not be empty
  push 0xA                     ;Create an object "{"
  push resultsStr              ;"results"
  push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON


  push 1                       ;may not be empty
  push 0xB                     ;end of the collection

    push [Deleted_files]
    call CountItems
    shr peax,1 ;devide by 2

    push64NumJson_buffer peax, 0x3 or 0x100000 ;counted Removed_files, push as doted like "5.000.000.000" and as number
    push removedfilesStr           ;"modifiedAttributes"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push [Added_files]
    call CountItems
    shr peax,1 ;devide by 2

    push64NumJson_buffer peax, 0x3 or 0x100000 ;counted Added_files, push as doted like "5.000.000.000" and as number
    push addedfilesStr           ;"modifiedAttributes"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push [Modified_Size_files]
    call CountItems
    shr peax,1 ;devide by 2

    push64NumJson_buffer peax, 0x3 or 0x100000 ;counted Modified_Size_files, push as doted like "5.000.000.000" and as number
    push modifiedSizeStr         ;"modifiedAttributes"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push [Modified_TimeDate_files]
    call CountItems
    shr peax,1 ;devide by 2

    push64NumJson_buffer peax, 0x3 or 0x100000 ;counted Modified_TimeDate_files, push as doted like "5.000.000.000" and as number
    push modifiedTimeDateStr     ;"modifiedAttributes"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push [Modified_Attributes_files]
    call CountItems
    shr peax,1 ;devide by 2

    push64NumJson_buffer peax, 0x3 or 0x100000 ;counted Modified_Attributes_files, push as doted like "5.000.000.000" and as number
    push modifiedAttributesStr   ;"modifiedAttributes"
    push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma

  push 1                       ;"May not be empty
  push 0xA                     ;Create an object "{"
  push statsStr                ;"stats"
  push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

  push 1                       ;may not be empty
  push 0xB                     ;end of the collection

    push [no_access_files2]
    call CountItems
    shr peax,1 ;devide by 2

    push64NumJson_buffer peax, 0x3 or 0x100000 ;counted unaccessable files, push as doted like "5.000.000.000" and as number
    push noAccessFilesStr        ;"NoAccessFiles"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push64NumJson_buffer TotalErrPath2, 0x4 or 0x100000 ;counted unaccessable paths, push as doted like "5.000.000.000" and as number
    push CountedErrPathStr       ;"NoAccessDirs"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push64NumJson_buffer CountedFiles2, 0x4 or 0x100000 ;counted files, push as doted like "5.000.000.000" and as number
    push CountedFilesStr         ;"files"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON


    push64NumJson_buffer CountedDirs2, 0x4 or 0x100000 ;counted dirs, push as doted like "5.000.000.000" and as number
    push CountedDirsStr          ;"dirs"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push64NumJson_buffer SizeCount2, 0x5 ;counted size, push as formated to "5GB (5.000.000.000 bytes)" and as number
    push CountedSizeStr          ;"size"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push [Path2]                 ;dir1
    push 0x2 or 0x200000 or 0x800000         ;UTF-16 or 0x200000=escape string as JSON string, 0x800000=is value in JSON object
    push PathStr                 ;"path"
    push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma

  push 1                       ;"May not be empty
  push 0xA                     ;Create an object "{"
  push path2Str                ;"dir2"
  push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

  push 1                       ;may not be empty
  push 0xB                     ;end of the collection

    push [no_access_files]
    call CountItems
    shr peax,1 ;devide by 2

    push64NumJson_buffer peax, 0x3 or 0x100000 ;counted unaccessable files, push as doted like "5.000.000.000" and as number
    push noAccessFilesStr        ;"files"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push64NumJson_buffer TotalErrPath, 0x4 or 0x100000 ;counted unaccessable paths, push as doted like "5.000.000.000" and as number

    push CountedErrPathStr       ;"files"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push64NumJson_buffer CountedFiles, 0x4 or 0x100000 ;counted files, push as doted like "5.000.000.000" and as number

    push CountedFilesStr         ;"files"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push64NumJson_buffer CountedDirs, 0x4 or 0x100000 ;counted dirs, push as doted like "5.000.000.000" and as number

    push CountedDirsStr          ;"dirs"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push64NumJson_buffer SizeCount, 0x5 ;counted size, push as formated to "5GB (5.000.000.000 bytes)" and as number

    push CountedSizeStr          ;"size"
    push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

    push [Path]                  ;dir1
    push 0x2 or 0x200000 or 0x800000         ;UTF-16 or 0x200000=escape string as JSON string, 0x800000=is value in JSON object

    push PathStr                 ;"path"
    push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma

  push 1                       ;"May not be empty
  push 0xA                     ;Create an object "{"
  push path1Str                ;"dir1"
  push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

  waitForLock [CurrentFileMemLock]

  push [CurrentFileMem]        ;current file
  push 0x2 or 0x200000 or 0x800000         ;UTF-16 or 0x200000=escape string as JSON string, 0x800000=is value in JSON object
  push CurrentFileStr          ;"CurrentFileStr"
  push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

  waitForLock [CurrentFolderMemLock]

  push [CurrentFolderMem]      ;current folder
  push 0x2 or 0x200000 or 0x800000         ;UTF-16 or 0x200000=escape string as JSON string, 0x800000=is value in JSON object
  push CurrentFolderStr        ;"currentFolder"
  push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

  push64NumJson_buffer FilesToChangeAttributes, 0x4 or 0x100000 ;counted dirs, push as doted like "5.000.000.000" and as number

  push FilesToChangeAttributesStr ;"filesToChangeAttributes"
  push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

  push64NumJson_buffer FilesToRemove, 0x4 or 0x100000 ;counted dirs, push as doted like "5.000.000.000" and as number

  push FilesToRemoveStr        ;"filesToRemove"
  push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

  push64NumJson_buffer SizeToBackup, 0x5 ;counted size, push as formated to "5GB (5.000.000.000 bytes)" and as number

  push CountedSizeToBackupStr  ;"sizeToBackup"
  push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

  call pushObstacles
  ;--push wDefRunningStr     help
 ;-- push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON


  if used is64
    push [cStarted]     ;amount of times 'Start' is called
  else
    push cStarted       ;amount of times 'Start' is called
  end if
  push 0x4              ;number
  push timesStartedStr  ;"timesStarted"
  push  0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

  push ScanningStr              ;"scanning"
  cmp [Working],1
  je isWorking

    mov pdword [pesp],backupingStr ;"backuping"
  cmp [Working],2
  je isWorking

    mov pdword [pesp],DoneStr ;"Done"
isWorking:

  push 0x1 or 0x200000 or 0x800000 ;ANSI or 0x200000=escape string as JSON string, 0x800000=is value in JSON object
  push statusStr   ;"status"
  push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

  push 1           ;success
  push 0x3         ;number
  push resultName  ;"result"
  push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma
  push 1                       ;"May not be empty
  push 0xA                     ;Create an object "{"
  push pedx                    ;buffer
  call appendBuffer

  ;release locks

  push pesi
  mov pesi,[CurrentFileMemLock]
  mov byte[pesi],0

  mov pesi,[CurrentFolderMemLock]
  mov byte[pesi],0

  ;release lock, so pointers can be freed again
  push [freeLock]
  call ExternalUnlockListWriteAcces

  pop pesi

  ;free and send buffer
  push pedx
  call freeBuffer
  xor pedx,pedx


  jmp errHandleConnection


;-----------------------------
;-----Get-No-Access-Dir1------
;-----------------------------
GetNoAccessDir1:
  if used is64
    xor r8,r8                  ;no result collection
    mov r12,no_access_files    ;the collection to work on
    mov r13,dno_access_files   ;the dword collection to work on
    mov r14,0x5                ;type for number
    xor r15,r15                ;You cannot select no access files
  else
    push 0                  ;no result collection
    push 0                  ;You cannot select no access files
    push 0x5                ;type for number
    push dno_access_files   ;the dword collection to work on
    push no_access_files    ;the collection to work on
    mov edx,esp
  end if
  jmp sendRequestedJsonList 

;-----------------------------
;-----Get-No-Access-Dir2------
;-----------------------------
GetNoAccessDir2:
  if used is64
    xor r8,r8                  ;no result collection
    mov r12,no_access_files2   ;the collection to work on
    mov r13,dno_access_files2  ;the dword collection to work on
    mov r14,0x5                ;type for number
    xor r15,r15                ;You cannot select no access files
  else
    push 0                    ;no result collection
    push 0                    ;You cannot select no access files
    push 0x5                  ;type for number
    push dno_access_files2    ;the dword collection to work on
    push no_access_files2     ;the collection to work on
    mov edx,esp
  end if
  jmp sendRequestedJsonList

;-----------------------------
;---------Get-Deleted---------
;-----------------------------
GetDeleted:
  if used is64
    mov r8,Deleted_files_result    ;the result collection
    mov r12,Deleted_files          ;the collection to work on
    mov r13,dDeleted_files         ;the dword collection to work on
    mov r14,0x5                    ;type for number
    mov r15,Deleted_files_selected ;List with selected files to delete
  else
    push Deleted_files_result      ;the result collection
    push Deleted_files_selected    ;List with selected files to delete
    push 0x5                       ;type for number
    push dDeleted_files            ;the dword collection to work on
    push Deleted_files             ;the collection to work on
    mov edx,esp
  end if
  jmp sendRequestedJsonList

;-----------------------------
;----------Get-Added----------
;-----------------------------
GetAdded:
  if used is64
    mov r8,Added_files_result    ;the result collection
    mov r12,Added_files          ;the collection to work on
    mov r13,dAdded_files         ;the dword collection to work on
    mov r14,0x5                  ;type for number
    mov r15,Added_files_selected ;List with selected files to add
  else
    push Added_files_result      ;the result collection
    push Added_files_selected    ;List with selected files to add
    push 0x5                     ;type for number
    push dAdded_files            ;the dword collection to work on
    push Added_files             ;the collection to work on
    mov edx,esp
  end if
  jmp sendRequestedJsonList

;-----------------------------
;----Get-Modified-DateTime----
;-----------------------------
GetModifiedDateTime:
  if used is64
    mov r8,Modified_TimeDate_files_result    ;the result collection
    mov r12,Modified_TimeDate_files          ;the collection to work on
    mov r13,dModified_TimeDate_files         ;the dword collection to work on
    mov r14,0xD                              ;type for number
    mov r15,Modified_TimeDate_files_selected ;List with selected files synchronise
  else
    push Modified_TimeDate_files_result      ;the result collection
    push Modified_TimeDate_files_selected    ;List with selected files to synchronise
    push 0xD                                 ;type for number
    push dModified_TimeDate_files            ;the dword collection to work on
    push Modified_TimeDate_files             ;the collection to work on
    mov edx,esp
  end if
  jmp sendRequestedJsonList

;-----------------------------
;---Get-Modified-Attributes---
;-----------------------------
GetModifiedAttributes:
  if used is64
    mov r8,Modified_Attributes_files_result    ;the result collection
    mov r12,Modified_Attributes_files          ;the collection to work on
    mov r13,dModified_Attributes_files         ;the dword collection to work on
    mov r14,0xC                                ;type for number
    mov r15,Modified_Attributes_files_selected ;List with selected files synchronise
  else
    push Modified_Attributes_files_result      ;the result collection
    push Modified_Attributes_files_selected    ;List with selected files to synchronise
    push 0xC                                   ;type for number
    push dModified_Attributes_files            ;the dword collection to work on
    push Modified_Attributes_files             ;the collection to work on
    mov edx,esp
  end if
  jmp sendRequestedJsonList

;-----------------------
;---Get-Modified-Size---
;-----------------------
GetModifiedSize:
  if used is64
    mov r8,Modified_Size_files_result    ;the result collection
    mov r12,Modified_Size_files          ;the collection to work on
    mov r13,dModified_Size_files         ;the dword collection to work on
    mov r14,0x5                          ;type for number
    mov r15,Modified_Size_files_selected ;List with selected files synchronise
  else
    push Modified_Size_files_result      ;the result collection
    push Modified_Size_files_selected    ;List with selected files to synchronise
    push 0x5                             ;type for number
    push dModified_Size_files            ;the dword collection to work on
    push Modified_Size_files             ;the collection to work on
    mov edx,esp
  end if

sendRequestedJsonList:
  call pushStartStr  ;push "start"
    db 'start',0
  pushStartStr:
  push pedi           ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz errStartMissing  ;jump if min is missing

  ;un-escape before use
  push ETBF_UNESCAPE_ADD_SIGN_AS_SPACE
  push peax
  call [ConvertEscapedCharactersToBytes]
  
  push 10
  push peax
  call StrToInt
  mov pesi,peax      ;ESI => start

  call pushLenStr  ;push "length"
    db 'length',0
  pushLenStr:
  push pedi           ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz errLenMissing  ;jump if length is missing

  ;un-escape before use
  push ETBF_UNESCAPE_ADD_SIGN_AS_SPACE
  push peax
  call [ConvertEscapedCharactersToBytes]
  
  push 10
  push peax
  call StrToInt
  mov pecx,peax      ;ECX => length

  ;set lock, so pointers cannot be freed until this action finishes
  push [freeLock]
  call LockListWriteAcces

  ;lock all lists
  if used is64
    test r8,r8
    jz noResultCollectionToLock
    push pdword [r8]   ;the result collection
  else
    mov eax,dword [edx+psize*4] ;get list with files
    test eax,eax
    jz noResultCollectionToLock
    push pdword [eax]   ;get list with files
  end if 
  call LockListWriteAcces
  noResultCollectionToLock:
  
  if used is64
    push pdword [r13]
  else
    mov eax,dword [edx+psize]
    push pdword [eax]
  end if 
  call LockListWriteAcces
  
  if used is64
    push pdword [r12]
  else
    mov eax,dword [edx]
    push pdword [eax]
  end if 
  call LockListWriteAcces
  
  if used is64
    test r15,r15
    jz noSelectedListToLock
    push pdword [r15]            ;List with selected files
  else
    mov eax,dword [edx+psize*3] ;List with selected files
    test eax,eax
    jz noSelectedListToLock
    push pdword [eax]           ;List with selected files
  end if 
  call LockListWriteAcces
  noSelectedListToLock:

  ;r8 is not automaticly saved by calls to TV's server
  if used is64
    push r8
  end if

  ;Free HTTPSession, since we don't need it anymore!
  push pebx
  call [FreeHTTPSession]

  ;r8 is not automaticly saved by calls to TV's server
  if used is64
    pop r8
  end if

  push pdword [pebp+psize*3] ;ClientSession (param2)
  push pdword [pebp+psize*2] ;ProtocolSession (param1)
  push sendBufferCacllback   ;callback function
  call createNewBuffer
  mov pebx,peax   ;R/EBX<=Buffer!!

  ;-mov peax,600
  ;-cmp peax,pecx
  ;-cmovc pecx,peax

  if used is32
    mov edi,edx ;the collection to work on and the typenumber             ;
  end if

  ;--add pesi,pecx ;start + min
  ;dec pesi
  xor edx,edx ;actual items count


  push 0 ;last item in list for appendBuffer
  push 1                     ;not empty
  push 0xA                   ;Create an object "{"
  push listStr               ;"list"
  push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma
  push 1                                        ;"May not be empty
  push 0xA                                      ;Create an object "{"
  push pebx
  call appendBuffer


  loopThroughSelectedItems:
    ;mov peax,pesi
    ;if used is32
    ;  shl peax,2 ;*4
    ;else
    ;  shl peax,1 ;*2
    ;end if
    
    if used is64
      push pdword [r12]  ;collection
    else
      mov eax,dword [edi] ;get collection from stack
      push pdword [eax]  ;collection
    end if
    call CountItems
    shr eax,1 ;/2
    cmp pesi,peax
    ja itemDoesntExist

    if used is64
      push pdword [r13]  ;dword collection
    else
      mov eax,dword [edi+0x4] ;get dword collection from stack
      push pdword [eax]  ;dword collection
    end if
    call CountItems
    if used is32
      shr eax,2 ;/4
    else
      shr rax,1 ;/2
    end if
    cmp pesi,peax
    ja itemDoesntExist

      push 0                       ;last item in list for appendBuffer
      push 1                       ;may not be empty
      push 0xB                     ;end of the collection

        if used is64
          test r15,r15
          jz dontSendSelectedValue
        else
          cmp dword [edi+0xC],0
          je dontSendSelectedValue
        end if

        push pesi  ;itemId
        if used is64
          push pdword [r15]  ;selected collection
          call GetDwordItem
        else
          mov eax,dword [edi+0xC] ;get selected collection from stack
          push pdword [eax]  ;selected collection
          call GetDwordItem
        end if
        
        push peax ;isSelected
        push 0xE  ;boolean
        push selectedStr ;'selected'
        push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON
        dontSendSelectedValue:

        if used is64
          test r8,r8
          jz dontSendResultValue
        else
          cmp dword [edi+0x10],0
          je dontSendResultValue
        end if

        push pesi  ;itemId
        if used is64
          push pdword [r8]  ;selected collection
          call GetDwordItem
        else
          mov eax,dword [edi+0x10] ;get selected collection from stack
          push pdword [eax]  ;selected collection
          call GetDwordItem
        end if
        
        push peax ;result
        push 0x3  ;number
        push resultStr ;'result'
        push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON
        dontSendResultValue:

        mov peax,pesi
        if used is32
          shl eax,2 ;*4
          dec eax ;get low part
        else
          shl rax,1 ;*2
        end if

        push peax
        if used is64
          push pdword [r13]  ;dword collection
          call GetDwordItem
        else
          mov eax,dword [edi+0x4] ;get dword collection from stack
          push pdword [eax]  ;dword collection
          call GetDwordItemPointer

          push edx  ;save EDX

          mov edx,dword [edi+0x8]  ;;get type of value

          and edx,0xFFFF  ;remove flags
          cmp edx,0x3
          je loadOnlyDword
          cmp edx,0x31
          je loadOnlyDword
          cmp edx,0xC
          jne keepPointerToQword
          ;cmp edx,0xD
          ;jne keepPointerToQword

          loadOnlyDword:
          mov eax,dword [eax] ;need dword instead of pointer to qword

          keepPointerToQword:
          pop edx ;restore EDX
        end if

        if used is64
          push64NumJsonNoPointer_buffer peax,r14
        else
          push64NumJsonNoPointer_buffer peax,dword [edi+0x8]
        end if


        push newStr                ;"new"
        push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

        mov peax,pesi
        if used is32
          shl eax,2 ;*4
          sub eax,3 ;get low part
        else
          shl rax,1 ;*2  ;Get old size
          dec rax
        end if


        push peax
        if used is64
          push pdword [r13]  ;dword collection
          call GetDwordItem
        else
          mov eax,dword [edi+0x4] ;get collection from stack
          push pdword [eax]  ;collection
          call GetDwordItemPointer

          push edx  ;save EDX

          mov edx,dword [edi+0x8]  ;;get type of value

          and edx,0xFFFF  ;remove flags
          cmp edx,0x3
          je loadOnlyDword2
          cmp edx,0x31
          je loadOnlyDword2
          cmp edx,0xC
          jne keepPointerToQword2
          ;cmp edx,0xD
          ;je keepPointerToQword2

          loadOnlyDword2:
          mov eax,dword [eax] ;need dword instead of pointer to qword

          keepPointerToQword2:
          pop edx ;restore EDX
        end if


        if used is64
          push64NumJsonNoPointer_buffer peax,r14
        else
          push64NumJsonNoPointer_buffer peax,dword [edi+0x8]
        end if

        push oldStr                ;"old"
        push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

        mov peax,pesi
        shl peax,1 ;*2  ;Get fielname
        dec eax         ;go to path

        push peax
        if used is64
          push pdword [r12]  ;collection
        else
          mov eax,dword [edi] ;get collection from stack
          push pdword [eax]  ;collection
        end if
        call GetItem

        push peax                  ;he path to the file
        push 0x2 or 0x200000 or 0x800000 ;unicode string , 0x200000=escape string as JSON string, 0x800000=is value in JSON object

        push PathStr               ;"path"
        push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

        mov peax,pesi
        shl peax,1 ;*2  ;Get fielname
        ;inc peax

        push peax
        if used is64
          push pdword [r12]  ;collection
        else
          mov eax,dword [edi] ;get collection from stack
          push pdword [eax]  ;collection
        end if
        call GetItem

        push peax                  ;the filename
        push 0x2 or 0x200000 or 0x800000 ;unicode string , 0x200000=escape string as JSON string, 0x800000=is value in JSON object

        push filenameStr           ;"filename"
        push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma

      push 1                       ;"May not be empty
      push 0xA                     ;Create an object "{"
      push pesi                    ;The item number in the list


      push 0x3 or 0x400000  ;number 0x400000=is item name in JSON

      test edx,edx
      jnz notFirst

        or pdword [pesp],0x1000000 ;0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma

      notFirst:
      push pebx
      call appendBuffer

      inc edx ;count actuall items

      if used is64
        push r8 ;is not saved by TV's server API
      end if

      push 0                     ;buf
      mov peax,pesp

      push 4                     ;len

      push pesp                  ;&len
      push peax                  ;buf
      push CSI_CONNECTION_ALIVE  ;type
      push pdword [pebp+psize*3] ;ClientSession (param2)
      push pdword [pebp+psize*2] ;ProtocolSession (param1)
      call [GetClientSessionInfo]

      pop peax  ;len
      pop peax  ;boolean is connection still alive

      if used is64
        pop r8 ;is not saved by TV's server API
      end if
      test peax,peax
      jz doneRequestedItems

  itemDoesntExist:
  ;cancel this action is start is trying to be executed
  cmp [tryToRestart],1
  je doneRequestedItems

    inc pesi
    dec pecx
  jnz loopThroughSelectedItems


 doneRequestedItems:
  ;unlock all lists
  if used is64
    test r8,r8
    jz noResultCollectionToUnlock
    push pdword [r8]   ;the result collection
  else
    mov eax,dword [edi+psize*4] ;get list with files
    test eax,eax
    jz noResultCollectionToUnlock
    push pdword [eax]   ;get list with files
  end if 
  call ExternalUnlockListWriteAcces
  noResultCollectionToUnlock:
  
  if used is64
    push pdword [r13]         ;get list with information about the files (dwords)
  else
    mov eax,dword [edi+psize] ;get list with information about the files (dwords)
    push pdword [eax]         ;get list with information about the files (dwords)
  end if 
  call ExternalUnlockListWriteAcces
  
  if used is64
    push pdword [r12]           ;get list with which files are selected
  else
    mov eax,dword [edi] ;get list with which files are selected
    push pdword [eax]           ;get list with which files are selected
  end if 
  call ExternalUnlockListWriteAcces
  
  if used is64
    test r15,r15
    jz noSelectedListToUnlock
    push pdword [r15]            ;List with selected files
  else
    mov eax,dword [edi+psize*3] ;List with selected files
    test eax,eax
    jz noSelectedListToUnlock
    push pdword [eax]           ;List with selected files
  end if 
  call ExternalUnlockListWriteAcces
  noSelectedListToUnlock:

  ;release lock, so pointers can be freed again
  push [freeLock]
  call ExternalUnlockListWriteAcces

  push 0                     ;end of list
  push 1                     ;may not be empty
  push 0xB                   ;end of the collection

  push pedx                  ;items in list
  push 0x3                   ;number

  push lenStr                ;"length"
  push 0x1 or 0x400000       ;ANSI string 0x400000=is item name in JSON
  push 1                     ;may not be empty
  push 0xB                   ;end of the collection
  push pebx
  call appendBuffer

  push pebx
  call freeBuffer
  xor pebx,pebx

  jmp errHandleConnection

goToExample:
mov edx,eax
;-----------------------------------------
;-------This code may be deleted----------
;-----------------------------------------

;-call CreateCollection
;-mov pecx,peax

;-call pushFirstTestString
;-  du 'Dit is een test',0

;-pushFirstTestString:
;-push pecx
;-call AddStringW

;-call pushSecondTestString
;-  du 'C:\Windows\system32\ntsokrnl.exe',0

;-pushSecondTestString:
;-push pecx
;-call AddStringW

  push pdword [pebp+psize*3] ;ClientSession (param2)
  push pdword [pebp+psize*2] ;ProtocolSession (param1)
  push sendBufferCacllback   ;callback function
  call createNewBuffer
  mov pecx,peax   ;R/EDX<=Buffer!!


  push 0              ; end of the list


  ;-push 2                ;end
  ;-push 1                ;begin

  push 1
  push 0xB ;;'}'
  push pedx
  push 0x3 ;--0x91              ;hash

  ;--push pedx
  ;--push 0x3              ;push hash
 call pushActionHashDecimalStr  ;push "ActionHashDecimal", the name of the JSON value

   db 'ActionHashDecimal',0
pushActionHashDecimalStr:
  push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

  push pedx
  push 0x31 or 0x800000              ;push hash as number 0x800000=is value in JSON object
 call pushActionHashStr  ;push "ActionHash", the name of the JSON value

   db 'ActionHash',0
pushActionHashStr:
  push 0x1 or 0x200000 or 0x400000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON

  call pushActionStr2  ;push  value  "action"

    db 'action',0

pushActionStr2:
  push pedi
  call [GetCollectionItem]  ;Get "action" from the question mark

  push peax                 ;push the value of the json item "Action"
  push 0x1 or 0x200000 or 0x800000 ;ANSI string , 0x200000=escape string as JSON string, 0x800000=is value in JSON object

 call pushSendStr           ;push "ACTION", the name of the JSON value

   db 'Action',0
pushSendStr:
  push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string 0x200000=escape string as JSON string, 0x400000=is item name in JSON, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma
  push 1
  push 0xA ;'{'
  push pecx
  call appendBuffer

   push pecx
   call freeBuffer
   xor pecx,pecx

   dontSendAction:

;---------------- END --------------------
;-------This code may be deleted----------
;-----------------------------------------

  jmp endHandleConnection
;call denter

;retryhigherConnectedPeople:
;  mov esi,0x1 ;GET_FROM_CLIENTSESSION
;  mov eax,1
;  call GetPluginDataInt ;(R/E)CX => maximum allowed connections

;  ;Get ListenSession
;  push pdword [pebp+psize*3]
;  push pdword [pebp+psize*2]
;  call [GetListenSessionFromClientSession]

;  ;find the data member of this protocol
;  push pdword [peax+8]       ;ProtocolData structure of ListenSession structure
;  push pdword [pebp+psize*2]                  ;psess
;  call [FindProtocolDataStruct]
;  lea pesi,pdword [peax+psize*2] ;data (current ConnectedPeople)

;  mov eax,dword [pesi] ;current connected people
;  mov edx,eax
;  inc edx     ;current connected people + 1

;  cmp edx,ecx
;  ja errHandleConnection ;To many connected people

;  lock cmpxchg [pesi],edx
;jnz retryhigherConnectedPeople

;call dleave

letOtherProtocolHandle:
  push pebx
  call FreeMemLocation
  call dleave

  call denter

  mov pedx,pdword [pebp+psize*2]  ;psess
  mov pecx,pdword [pebp+psize*3]  ;sess

  ;call the next HandleConnection function from the other protocols
  push pecx       ;sess
  push pedx       ;psess
  call [CallNextHandleConnection]
;push peax ;save returned value

;;Get ListenSession
;push pdword [pebp+psize*3]
;push pdword [pebp+psize*2]
;call [GetListenSessionFromClientSession]

;push pdword [peax+8]       ;ProtocolData structure of ClientSession structure
;push pdword [pebp+psize*2]                  ;psess
;call [FindProtocolDataStruct]

;lock dec dword [peax+psize*2]  ;decrement connected people\

;pop peax ;restore return value

endHandleConnection:
call dleave
EndProc 2
ret (FunctionReturnFactor*2)

errHandleConnection:
  test pebx,pebx
  jz dontReleaseHTTPSession

  push pebx
  call [FreeHTTPSession]

dontReleaseHTTPSession:

xor eax,eax
inc eax
jmp endHandleConnection

;------------------------------------------------------------------------------
;pushes the JSon structure for obstacles on stack
;corrupts R/EAX
;------------------------------------------------------------------------------
pushObstacles:
pop peax ;return address

    push 1
    push 0x10         ;']'

      push 1
      push 0xB         ;'}'

        push wDefUrlStr
        push 0x1 or 0x200000 or 0x800000    ;ANSI string, 0x200000=escape string as JSON string, 0x800000=is value in JSON object
        push disableManualUrlStr ;'disableManualUrl'
        push 0x1 or 0x200000 or 0x400000 ;ANSI string, 0x200000=escape string as JSON string, 0x400000=is item name in JSON object

        push peax ;save return address

        call IsWindowsDefenderRunning

        xchg peax,pdword [pesp]   ;true/false  and restore return address

        ;--push peax       ;true/false
        push 0xE        ;boolean
        push runningStr ;running
        push 0x1 or 0x200000 or 0x400000 ;ANSI string, 0x200000=escape string as JSON string, 0x400000=is item name in JSON object

        push wDefStr  ;'Windows Defender Realtime Security'
        push 0x1 or 0x200000 or 0x800000 ;ANSI string, 0x200000=escape string as JSON string, 0x800000=is value in JSON object
        push displayNameStr ;'displayName'
        push 0x1 or 0x200000 or 0x400000 or 0x1000000 ;ANSI string, 0x200000=escape string as JSON string, 0x400000=is item name in JSON object, 0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma

      push 1
      push 0xA         ;'{'

    push 1
    push 0xF         ;'['

    push obstaclesStr
    push 0x1 or 0x200000 or 0x400000 ;ANSI string, 0x200000=escape string as JSON string, 0x400000=is item name in JSON object

jmp peax

;------------------------------------------------------------------------------
;This function will manipulate the received data
;------------------------------------------------------------------------------
RecvData_Man:
StartProc 6 ;Set arguments on stack


jmp [RecvData]

;------------------------------------------------------------------------------
;This function will manipulate the send data
;------------------------------------------------------------------------------
SendData_Man:
StartProc 6 ;Set arguments on stack
jmp [SendData]


;(param1, param2, buffer, size)
sendBufferCacllback:
call denter

  lea pecx,pdword [pebp+psize*5]

  push pecx                  ;&len
  push pdword [pebp+psize*4] ;buff
  push DEFAULT_SENDTIMEOUT   ;maxTimeToReceive
  push 0                     ;flags
  push pdword [pebp+psize*3] ;ClientSession
  push pdword [pebp+psize*2] ;ProtocolSession
  call [SendData]

call dleave
ret psize*4