@ECHO OFF
setlocal enabledelayedexpansion

SET INCLUDE=C:\fasm\INCLUDE
SET @FASM_COMPILER=C:\fasm\FASM.EXE
SET @TVS_SERVER_SOURCE=%~dp0\tvserver\
SET @BACKUP_WEB_INTERFACE=webinterface\

net session >nul 2>&1
if %errorLevel%==0 goto runningasadmin

set "batchPath=%~f0"

echo This script needs admin priviliges to be able to install Copy OneOnOne.
echo Starting as admin...
REM Try to start the script with admin priviliges
ECHO Set UAC = CreateObject^("Shell.Application"^) > "%temp%\OEgetPrivileges.vbs"
ECHO UAC.ShellExecute "cmd", "/c ""%batchPath% """, "%~dp0\", "runas", 1 >> "%temp%\OEgetPrivileges.vbs"
"%temp%\OEgetPrivileges.vbs" 
exit /B

:runningasadmin
cd /d %~dp0
SET @DIR=%~dp0
%@DIR:~0,2%
  
echo Welcome to the installer of Copy OneOnOne
echo Please check the settings below before continue
echo --
echo FASM compiler path: %@FASM_COMPILER%
echo FASM include folder: %INCLUDE%
echo TV's server source: %@TVS_SERVER_SOURCE%
echo Copy OneOnOne web interface: %@BACKUP_WEB_INTERFACE%
echo --
echo Modify this file if not correct.
echo -
echo Download and unzip TV's server source (v3.2 or higher) in the correct directory before continuing. This is not done automatically. You can download it from https://www.tychoveltmeijer.nl/.
pause
cls

if not exist "%@FASM_COMPILER%" echo Cannot find the FASM compiler at %@FASM_COMPILER%. Please configure the path correctly in this bat file or download flat assembler from http://flatassembler.net/download.php.&pause&goto :EOF
if not exist "%INCLUDE%" echo Cannot find the FASM include folder at %INCLUDE%. Please configure this path correctly in this bat file or download flat assembler from http://flatassembler.net/download.php.&pause&goto :EOF
if not exist "%@TVS_SERVER_SOURCE%" echo Cannot find TV's server source at %@TVS_SERVER_SOURCE%. Please configure the path correctly in this bat file or download TV's server from https://www.tychoveltmeijer.nl/.&pause&goto :EOF
if not exist "%@BACKUP_WEB_INTERFACE%" echo Could not locate the web interface folder at %@BACKUP_WEB_INTERFACE%.Please configure the path correctly in this bat file.&pause&goto :EOF

SET @EXTRABYTES=
SET @COMPILE_ARCHITECTURE=x86
SET @BASE_NUMBER=32
set @REGISTRY_BASE=HKLM\SOFTWARE\TV's software\TV's backup system
set @REGISTRY_PATH=SOFTWARE\TV's software\TV's backup system
set @REGISTRY_PATH_BOTH=SOFTWARE\TV's software\TV's backup system
set @SysDir=%SystemRoot%\System32\
if not "%PROCESSOR_ARCHITECTURE%"=="AMD64" goto 32BIT

set @REGISTRY_BASE=HKLM\SOFTWARE\WOW6432Node\TV's software\TV's backup system
set @REGISTRY_PATH=SOFTWARE\WOW6432Node\TV's software\TV's backup system
set @SysDir=%SystemRoot%\SysWOW64\
:loop
echo Would you like to install the 32-bit version or the 64-bit version?
echo --
echo 1:32-bit
echo 2:64-bit
set /p id="Enter [1-2, default 2]: "
if "%id%"=="" goto 64BIT
if %id%==1 goto 32BIT
if not %id%==2 goto loop

:64BIT
set @REGISTRY_BASE=HKLM\SOFTWARE\TV's software\TV's backup system
set @REGISTRY_PATH=SOFTWARE\TV's software\TV's backup system
set @SysDir=%SystemRoot%\System32\
SET @COMPILE_ARCHITECTURE=x64
SET @BASE_NUMBER=64
SET @EXTRABYTES=00000000

:32BIT
:ASKPORTNUMBER
  set DEC=
  set var=
  set /P DEC=" On which port should Copy OneOnOne run? (1-65535, default 4440): "
  SET "var="&for /f "delims=0123456789" %%i in ("%DEC%") do set var=%%i
  if defined var goto ASKPORTNUMBER
  if "%DEC%"==""  goto setDefaultPort
  if %DEC% gtr 65535 goto ASKPORTNUMBER

  cmd /C exit %DEC%
  set "HEX=%=ExitCode%"

  if not %HEX%==00000000 goto isNotZeroPort
  :setDefaultPort
  SET HEX=00001158
  set DEC=4440
  :isNotZeroPort
  SET FIRSTBYTE=%HEX:~6,2%
  SET SECONDBYTE=%HEX:~4,2%

  :checkPortAvailable
  set result=
  call :isPortExcluded !DEC! result
  if !result!==1 (
    :askPortEnable
    echo This port is excluded for use

    echo 1:Make the port usable
    echo 2:Pick an other port
    set makePortUseable=
    set /p makePortUseable="Enter [1-2, default 2]: "

    if !makePortUseable!==2 goto ASKPORTNUMBER
    if not !makePortUseable!==1 goto askPortEnable
    
    net stop winnat >nul 2>&1
    netsh int ipv4 delete excludedportrange protocol=tcp !DEC! 1
    net start winnat >nul 2>&1
    goto checkPortAvailable
  )

  set result=
  call :isPortInuse !DEC! result
  if !result!==1 (
    :askPortInUse
    set answer=
    set /p answer="This port seems to be in use by an other program, are you sure you want to configure this port? (Y/N): "
    
    if !answer!==n goto ASKPORTNUMBER
    if !answer!==N goto ASKPORTNUMBER
    if !answer!==Y goto usePortAnyway
    if not !answer!==y goto askPortInUse

  )

:usePortAnyway

:askForShortcut
set shortcuts=
set /p shortcuts="Do you want to create shortcuts on the desktop? (Y/N, default Y): "

set createShortCuts=yes
if !shortcuts!==n set createShortCuts=no&goto shortcutQuestionIsAsked
if !shortcuts!==N set createShortCuts=no&goto shortcutQuestionIsAsked
if !shortcuts!==Y goto shortcutQuestionIsAsked
if !shortcuts!==y goto shortcutQuestionIsAsked
if not "!shortcuts!"=="" goto askForShortcut

:shortcutQuestionIsAsked
for %%i in (*.asm) do (
  echo compiling %%i
  for /f "delims=" %%j in ('%@FASM_COMPILER% %%i 2^>^&1') do (
    echo %%j
    set RESULT=%%j
  )
  echo:
  REM %@FASM_COMPILER% %%i

  set ret=0
  if "!RESULT:~0,6!"=="error:" call :errorCompilingTVbackupsystem ret
  
  if not "!ret!"=="0" goto endProgram
)

cd /d %@TVS_SERVER_SOURCE%
for %%i in (*.asm) do (
  echo compiling %%i
  for /f "delims=" %%j in ('%@FASM_COMPILER% %%i 2^>^&1') do (
    echo %%j
    set RESULT=%%j
  )
  echo:
  REM %@FASM_COMPILER% %%i
  
  set ret=0
  if "!RESULT:~0,6!"=="error:" call :errorCompilingServer ret
  if not "!ret!"=="0" goto endProgram
)

cls
SET str=%ComSpec%
set str=%str:cmd.exe=%

if not exist %str%reg.exe goto writeRegFile

echo Removing Registry settings...
reg delete "%@REGISTRY_BASE%" /f >nul 2>&1

echo Setting Registry...
reg add "%@REGISTRY_BASE%\Modules" /f /v "TV's backup system" /t REG_SZ /d "%~dp0\tvs_server_plugin_backup_system_%@COMPILE_ARCHITECTURE%.dll" >nul
reg add "%@REGISTRY_BASE%\Modules" /f /v "HTTP plug-in" /t REG_SZ /d "%@TVS_SERVER_SOURCE%tvs_server_plugin_http_%@COMPILE_ARCHITECTURE%.dll" >nul
reg add "%@REGISTRY_BASE%\Modules" /f /v "TCP/IP plug-in" /t REG_SZ /d "%@TVS_SERVER_SOURCE%tvs_server_plugin_tcp_protocol_%@COMPILE_ARCHITECTURE%.dll" >nul

reg add "%@REGISTRY_BASE%\ListenSessions\1" /f /v "BindedToProtocols" /t REG_MULTI_SZ /d TVS_SOFTWARE_TCPIP\0TVS_SOFTWARE_BACKUP_SYSTEM\0TVS_SOFTWARE_HTTP >nul
reg add "%@REGISTRY_BASE%\ListenSessions\1" /f /v "Name" /t REG_SZ /d "Copy OneOnOne" >nul

reg add "%@REGISTRY_BASE%\ListenSessions\1\TVS_SOFTWARE_BACKUP_SYSTEM" /f /v ProtocolType /t REG_DWORD /d 1 >nul
reg add "%@REGISTRY_BASE%\ListenSessions\1\TVS_SOFTWARE_HTTP" /f /v ProtocolType /t REG_DWORD /d 131074 >nul
reg add "%@REGISTRY_BASE%\ListenSessions\1\TVS_SOFTWARE_HTTP\listById" /f /v 1 /t REG_SZ /d "%~dp0%@BACKUP_WEB_INTERFACE%\" >nul
reg add "%@REGISTRY_BASE%\ListenSessions\1\TVS_SOFTWARE_HTTP\listById" /f /v 3 /t REG_BINARY /d 00 >nul
reg add "%@REGISTRY_BASE%\ListenSessions\1\TVS_SOFTWARE_HTTP\listById" /f /v 9 /t REG_BINARY /d 00 >nul
reg add "%@REGISTRY_BASE%\ListenSessions\1\TVS_SOFTWARE_TCPIP" /f /v ProtocolType /t REG_DWORD /d 0 >nul
reg add "%@REGISTRY_BASE%\ListenSessions\1\TVS_SOFTWARE_TCPIP\listById" /f /v 3 /t REG_BINARY /d %FIRSTBYTE%%SECONDBYTE%0000%@EXTRABYTES% >nul

goto finishInstallation

:writeRegFile
echo REGEDIT4 > reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%]>> reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\ListenSessions]>> reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\ListenSessions\1]>> reg.reg
echo "BindedToProtocols"=hex(7):54,56,53,5f,53,4f,46,54,57,41,52,45,5f,54,43,50,49,\>> reg.reg
echo   50,00,54,56,53,5f,53,4f,46,54,57,41,52,45,5f,42,41,43,4b,55,50,5f,53,59,53,\>> reg.reg
echo   54,45,4d,00,54,56,53,5f,53,4f,46,54,57,41,52,45,5f,48,54,54,50,00,00>> reg.reg
echo "Name"="Copy OneOnOne">> reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\ListenSessions\1\TVS_SOFTWARE_BACKUP_SYSTEM]>> reg.reg
echo "ProtocolType"=dword:00000001>> reg.reg
echo.>> reg.reg

echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\ListenSessions\1\TVS_SOFTWARE_HTTP]>> reg.reg
echo "ProtocolType"=dword:00020002>> reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\ListenSessions\1\TVS_SOFTWARE_HTTP\listById]>> reg.reg
set string=%~dp0%@BACKUP_WEB_INTERFACE%
set newString=
call :dubbleSlash
echo "1"="%newString%">> reg.reg
echo "3"=hex:00>> reg.reg
echo "9"=hex:00>> reg.reg
echo.>> reg.reg

echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\ListenSessions\1\TVS_SOFTWARE_TCPIP]>> reg.reg
echo "ProtocolType"=dword:00000000>> reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\ListenSessions\1\TVS_SOFTWARE_TCPIP\listById]>> reg.reg
echo "3"=hex:%FIRSTBYTE%,%SECONDBYTE%,00,00>> reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\Modules]>> reg.reg
set string=%~dp0\tvs_server_plugin_backup_system_%@COMPILE_ARCHITECTURE%.dll
set newString=
call :dubbleSlash
echo "TV's backup system"="%newString%">> reg.reg
set string=%@TVS_SERVER_SOURCE%tvs_server_plugin_http_%@COMPILE_ARCHITECTURE%.dll
set newString=
call :dubbleSlash
echo "HTTP plug-in"="%newString%">> reg.reg
set string=%@TVS_SERVER_SOURCE%tvs_server_plugin_tcp_protocol_%@COMPILE_ARCHITECTURE%.dll
set newString=
call :dubbleSlash
echo "TCP/IP plug-in"="%newString%">> reg.reg
echo.>> reg.reg
echo.>> reg.reg

start /wait regedit "%~dp0%@TVS_SERVER_SOURCE%reg.reg"

:finishInstallation
echo Uninstalling service if exist...
start /wait base%@BASE_NUMBER%_win.exe -u -r"%@REGISTRY_PATH_BOTH%" -n"Copy OneOnOne (%@COMPILE_ARCHITECTURE%)"

echo copying tvs_server_http_protocol_%@COMPILE_ARCHITECTURE%.dll to the system directory...
echo If this step fails, please copy manually to %@SysDir%
copy /Y "%@TVS_SERVER_SOURCE%\tvs_server_http_protocol_%@COMPILE_ARCHITECTURE%.dll" "%@SysDir%\tvs_server_http_protocol_%@COMPILE_ARCHITECTURE%.dll"

echo Installing service...
start /wait base%@BASE_NUMBER%_win.exe -i -r"%@REGISTRY_PATH_BOTH%" -n"Copy OneOnOne (%@COMPILE_ARCHITECTURE%)" -d"Copy OneOnOne API/1.00 (%@COMPILE_ARCHITECTURE%)"

echo Starting service...
start /wait base%@BASE_NUMBER%_win.exe -r"%@REGISTRY_PATH_BOTH%" -n"Copy OneOnOne (%@COMPILE_ARCHITECTURE%)"

if "!createShortCuts!"=="yes" (
  echo Creating shortcuts...
  
  set "SHRT_LOCA=%PUBLIC%\Desktop\Copy OneOnOne control panel (%@COMPILE_ARCHITECTURE%).url"
  set "SHRT_DEST=http://127.0.0.1:!DEC!/"
  echo [InternetShortcut]> "!SHRT_LOCA!"
  echo URL=!SHRT_DEST!>> "!SHRT_LOCA!"
  
  set "SHRT_LOCA=%PUBLIC%\Desktop\Start Copy OneOnOne (%@COMPILE_ARCHITECTURE%).url"
  set "SHRT_DEST=%~dp0\gui_%@COMPILE_ARCHITECTURE%.exe"
  echo [InternetShortcut]> "!SHRT_LOCA!"
  echo URL=file:///!SHRT_DEST!>> "!SHRT_LOCA!"
)

echo Starting Copy OneOnOne
start http://127.0.0.1:!DEC!/
echo Done.
pause
exit /B 0

:errorCompilingServer
echo Error compiling TV's server
call :askForContinuation ret

if !retv! == 1 set "%~1 = 1"
if not !retv! == 1 set "%~1 = 0"
goto :eof

:errorCompilingTVbackupsystem
echo Error compiling Copy OneOnOne
set ret=
call :askForContinuation ret

set %~1=!ret!

goto :eof

:askForContinuation
if "!ytoall!"=="" set ytoall=0

if !ytoall!==1 goto answerYes

set answer=
set /p answer="Would you like to continue anyway (Y/N/Y2ALL): "
set newString=

:lowerAnswer
set CHAR=!answer:~0,1!

if "!CHAR!"==" " goto notBackSlashlower

if !CHAR!==y set CHAR=Y

if !CHAR!==a set CHAR=A

if !CHAR!==l set CHAR=L

if !CHAR!==n set CHAR=N

:notBackSlashlower
set newString=!newString!!CHAR!
set answer=!answer:~1!
if not "!answer!"=="" goto lowerAnswer

if "!newString!"=="Y" goto answerYes
if "!newString!"=="Y2ALL" set ytoall=1&goto answerYes
if "!newString!"=="N" goto answerNo

goto askForContinuation

:answerNo
set %~1=1
goto :eof

:answerYes
set %~1=0
goto :eof


:dubbleSlash
set newString=
set CHAR=!string:~0,1!

if "!CHAR!"==" " goto notBackSlash

if !CHAR!==\ (
set CHAR=\\
)
:notBackSlash
set newString=!newString!!CHAR!
set string=!string:~1!
if not "!string!"=="" goto dubbleSlash
goto :eof

:endProgram
EXIT /B 1

:isPortExcluded
set %~2=0
if not exist "%SystemRoot%\System32\netsh.exe" goto :EOF

set curPort=%~1
for /f "delims=" %%j in ('netsh int ipv4 show excludedportrange tcp') do (
  set mvar="%%j"
  set isTaken=0
  call :processLineNetsh !mvar! !curPort! isTaken
  if !isTaken! == 1 set %~2=1
)
:endIsPortExcluded
goto :EOF


:processLineNetsh
  set line=%~1%
  set %~3=0
  if not "!line:~0,1!"==" " goto :EOF
  
  set isHigh=0
  set lowNumber=
  set highNumber=
  :findNumber
  set line=!line:~1!
  if "!line:~0,1!"==" " goto findNumber
  
  if !isHigh!==1 set highNumber=!highNumber!!line:~0,1!
  if !isHigh!==0 set lowNumber=!lowNumber!!line:~0,1!
  
  if "!line:~1,1!"=="" goto foundNumber
  if not "!line:~1,1!"==" " goto findNumber
  if !isHigh!==0 set isHigh=1&goto findNumber
  
  :foundNumber
  set var=
  SET "var="&for /f "delims=0123456789" %%i in ("!lowNumber!") do set var=%%i
  if defined var goto :EOF
  set var=
  SET "var="&for /f "delims=0123456789" %%i in ("!highNumber!") do set var=%%i
  if defined var goto :EOF

  set curNumber=%~2%
  if !curNumber! lss !lowNumber! goto :EOF
  if !curNumber! gtr !highNumber! goto :EOF
  set %~3=1
goto :EOF

:isPortInuse
set curPort=%~1
set %~2=0

if not exist "%SystemRoot%\System32\netstat.exe" goto :EOF
netstat -a -o -n -p tcp 0 | find /i "listening" | find ":!curPort!" >nul 2>nul && (
   set %~2=1
) || (
  set %~2=0
)
goto :EOF