
;Copy OneOnOne 1.00
;Copyright (c) 2022, Tycho Veltmeijer.
;All rights reserved.

include 'win64w.inc'

SystemName equ 'Windows'
CPUname equ 'x64'
CPUArchitecture equ 'amd64'

;Enable if you want to enable LOGGING
;virtual at 0
;call LOG
;LOG:
;end virtual

;64 BIT Equ's
ClearSpaceForAPI     equ 8*16
UsedSizeBydEnter     equ 0x28 *2 ;0x2C *2
FunctionReturnFactor equ 0
scasp equ scasq
movsp equ movsq
jpcxz equ jrcxz

psize       equ 8
pointer     equ dq
pdword      equ qword
peax        equ rax
pecx        equ rcx
pebx        equ rbx
pedx        equ rdx
pedi        equ rdi
pesi        equ rsi
pebp        equ rbp
pesp        equ rsp

;nonvolatile values
nvecx       equ r12
nvedx       equ r13

;nonvolatile values
nvecxd       equ r12d
nvedxd       equ r13d

macro initLinux
{common
}


;With this you can use the macro 'if used is64'
virtual at 0
call is64
is64:
end virtual

virtual at 0
call isWin
isWin:
end virtual

macro StartProc num
{ common
mov qword [rsp+0x8],rcx
if num = 2 | num = 3 | num = 4 | num = 5 | num = 6 | num = 7  | num = 8 | num = 9  | num = 10
   mov qword [rsp+0x10],rdx
end if
if num = 3 | num = 4 | num = 5 | num = 6 | num = 7  | num = 8 | num = 9  | num = 10
   mov qword [rsp+0x18],r8
end if
if num = 4 | num = 5 | num = 6 | num = 7  | num = 8 | num = 9  | num = 10
   mov qword [rsp+0x20],r9
end if
}

macro EndProc num
{ common
}

macro ClearStack
{ common
  ;add rsp,ClearSpaceForAPI
  ;undoFixStack
}

macro undoFixStack
{ common
  add rsp,qword [rsp]
  add rsp,8
}

macro MakeStack
{ common

  fixStack 0
  sub rsp,ClearSpaceForAPI

}

macro fixStack pushAnnyway
{ common
  local ..unevenStack
  local ..dontPush

  mov rax,rsp

  shr rax,4
  if pushAnnyway=1
    jc ..unevenStack

    push 0

    ..unevenStack:
    rcr rax,1
    shr rax,29+31
    xor eax,8
    push rax
  else
    jnc ..dontPush

    push 0

    ..dontPush:
  end if
}

macro argpush num,arg
{ common

if arg eqtype 0
        size@arg = 8
       else if arg eqtype byte 0
        virtual at 0
         mov [rbx],arg
         local opcode
         load opcode byte from 0
         if opcode and 0F8h = 48h
          size@arg = 8
         else if opcode = 66h
          size@arg = 2
         else if opcode = 0C7h
          size@arg = 4
         else
          size@arg = 1
         end if
        end virtual
       else
        virtual at 0
         inc arg
         local opcode
         load opcode byte from 0
         if opcode = 67h
          load opcode byte from 1
         end if
         if opcode and 0F8h = 48h
          size@arg = 8
         else if opcode = 66h
          size@arg = 2
         else if opcode = 0FFh
          size@arg = 4
         else
          size@arg = 1
         end if
        end virtual
       end if

    if size@arg = 8
       if num = 1
          if arg eq rcx
          else
             if arg eq 0
               xor ecx,ecx
             else
               mov rcx,arg
             end if
          end if
       else
          if num = 2
             if arg eq rdx
             else
               if arg eq 0
                 xor edx,edx
               else
                mov rdx,arg
              end if
             end if
          else
             if num = 3
                if arg eq r8
                else
                  if arg eq 0
                     xor r8,r8
                   else
                    mov r8,arg
                  end if

                end if

             else
                if num = 4
                   if arg eq r9
                   else
                      if arg eq 0
                        xor r9,r9
                      else
                        mov r9,arg
                      end if
                   end if
                else
                   mov qword [rsp+((num-1)*8)],arg
                end if
             end if
           end if
       end if
    end if

    if size@arg = 4
       if num = 1
          mov ecx,arg
       else
          if num = 2
             mov edx,arg
          else
             if num = 3
                mov r8d,arg
             else
                if num = 4
                   mov r9d,arg
                else
                   mov qword [rsp+((num-1)*8)],0
                   mov dword [rsp+((num-1)*8)],arg
                end if
             end if
           end if
       end if
    end if

    if size@arg = 2
       if num = 1
          mov cx,arg
       else
          if num = 2
             mov dx,arg
          else
             if num = 3
                mov r8w,arg
             else
                if num = 4
                   mov r9w,arg
                else
                   mov word [rsp+((num-1)*8)],arg
                end if
             end if
           end if
       end if
    end if

    if size@arg = 1
       if num = 1
          mov al,arg
       else
          if num = 2
             mov dl,arg
          else
             if num = 3
                mov r8b,arg
             else
                if num = 4
                   mov r8b,arg
                else
                   mov qword [rsp+((num-1)*8)],0
                   mov byte [rsp+(((num-1)-1)*8)],arg
                end if
             end if
           end if
       end if
    end if
}

macro argpop num,arg
{ common

       if num = 1
          mov arg,rcx
       else
          if num = 2
             mov arg,rdx
          else
             if num = 3
                mov arg,r8
             else
                if num = 4
                   mov arg,r9
                else
                   mov arg,qword [rsp+((num-1)*8)]
                end if
             end if
           end if
       end if

}

if used denter
        denter:
        pop rax
        push rdi
        push rsi
        push rbx
        push rdx
        push rcx
        push r8
        ;push r9
        push r12
        push r13
        push r14
        push r15
        push rbp

        mov rbp,rsp
        add rbp,0x28*2;0x2C*2
        jmp rax
end if

if used dleave
        dleave:
        pop rcx
        mov rsp,rbp
        sub rsp,0x28*2;0x2C*2
        push rcx
        add rsp,0x4*2
        pop rbp
        pop r15
        pop r14
        pop r13
        pop r12
        ;pop r9
        pop r8
        pop rcx
        pop rdx
        pop rbx
        pop rsi
        pop rdi
        jmp qword [rsp-0x60] ;[rsp-0x68]
end if

if used saveVolatileRegister
macro saveVolatileRegister {
    ;mov r12,rcx
    ;mov r13,rdx
}
end if

if used restoreVolatileRegister
macro restoreVolatileRegister {
    ;mov rcx,r12
    ;mov rdx,r13
}
end if

macro lodsp {
   lodsq
}

stosp equ stosq

;macro stosp {
;   stosq
;}





