
;Copy OneOnOne 1.00
;Copyright (c) 2022, Tycho Veltmeijer.
;All rights reserved.

;Functions :
;GetServiceState
;IsWindowsDefenderRunning

if used wDefenderName
  wDefenderName du 'WdNisSvc',0
end if

;------------------------------------------------------------------------------
;This function will return true is Windows Defender is running, or false if not
;input:
;   none
;output:
;    (R/E)AX=>
;       True:  Windows defender is running
;       False: Windows defender is not running
;------------------------------------------------------------------------------
if used IsWindowsDefenderRunning
IsWindowsDefenderRunning:
mov peax,wDefenderName
xchg pdword [pesp],peax ;swap return pointer with 'WdNisSvc'
push peax ;push return pointer
;jmp IsServiceRunning
end if

;------------------------------------------------------------------------------
;This function will return true is the service is running, or false if not
;input:
;   1: Service name
;output:
;    (R/E)AX=>
;       True:  Windows defender is running
;       False: Windows defender is not running
;------------------------------------------------------------------------------
if used IsServiceRunning | used IsWindowsDefenderRunning
IsServiceRunning:

push pdword [pesp+psize] ;name of the service to open
call GetServiceState

cmp eax,0x4 ;SERVICE_RUNNING
jne ServiceisNotRunning

mov eax,1
jmp endIsServiceRunning

ServiceisNotRunning:
xor eax,eax

endIsServiceRunning:
ret psize*1
end if

;------------------------------------------------------------------------------
;This function will return the status of the current external running process
;input:
;   1:Service name (ANSI)
;output:
;    (R/E)AX=>
;       0x0 NOT_INSTALLED The service is not installed or we have no privillage to get the service status
;       0x1 SERVICE_STOPPED The service is not running.
;       0x2 SERVICE_START_PENDING The service is starting.
;       0x3 SERVICE_STOP_PENDING The service is stopping.
;       0x4 SERVICE_RUNNING The service is running.
;       0x5 SERVICE_CONTINUE_PENDING The service continue is pending.
;       0x6 SERVICE_PAUSE_PENDING The service pause is pending.
;       0x7 SERVICE_PAUSED The service is paused.
;------------------------------------------------------------------------------
if used GetServiceState
GetServiceState:
call denter

sub pesp,7*4 ;creat a SERVICE_STATUS structure
if used is64
  sub pesp,4
end if
mov pedi,pesp ;(R/E)DI => pointer to a SERVICE_STATUS structure
mov dword [pedi+4],0 ;set currentstatus to zero (not installed)

MakeStack

argpush 3,0x1           ;SC_MANAGER_CONNECT  ;--0x4             ;SERVICE_QUERY_STATUS
argpush 2,0
argpush 1,0
call [OpenSCManagerW]
test peax,peax
jz endGetServiceState

mov pesi,peax ;(R/E)SI => result of OpenSCManagerA

;open handle to service TV's server v3
argpush 3,0x4                   ;SERVICE_QUERY_STATUS
argpush 2,pdword [pebp+psize*2] ;name of the service to open
argpush 1,peax                  ;hServiceManager
call [OpenServiceW]
test peax,peax
jz OpenServiceFailed2

mov pebx,peax;(R/E)BX => handle to service

argpush 2,pedi
argpush 1,pebx
call [QueryServiceStatus]

;close handle to service
argpush 1,pebx
call [CloseServiceHandle]

OpenServiceFailed2:
;close handle to service manager
argpush 1,pesi
call [CloseServiceHandle]

endGetServiceState:
mov eax,dword [pedi+4] ;EAX => currentstatus
call dleave
ret psize
end if

